package  com.oxylusflash.comingSoon  
{
	//importing classes
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.SecurityErrorEvent;
	import flash.events.TimerEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.ui.ContextMenuBuiltInItems;
	import flash.utils.Timer;
	import com.oxylusflash.util.StringUtil;
	import com.oxylusflash.events.ParamEvent;
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.ColorShortcuts;
	ColorShortcuts.init(); 
	
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	
	public class ContactInfo extends Sprite
	{
		//declaring variables
		public var Title:TextField;
		public var Description:TextField;
		public var nameTitle:TextField;
		public var subjectTitle:TextField;
		public var emailTitle:TextField;
		public var messageTitle:TextField;
		public var nameBody:Sprite;
		public var mailBody:Sprite;
		public var subjectBody:Sprite;
		public var messageBody:Sprite;
		public var sendButton:SendButton;
		public var statusBox:TextField;
		private var nameText:TextField;
		private var emailText:TextField;
		private var subjectText:TextField;
		private var messageText:TextField;
		private var statusText:TextField;
		private var nameRedLine:Sprite;
		private var mailRedLine:Sprite;
		private var subjectRedLine:Sprite;
		private var messageRedLine:Sprite;
		private var sheet:StyleSheet;
		private var nameOverState:Sprite;
		private var mailOverState:Sprite;
		private var subjectOverState:Sprite;
		private var messageOverState:Sprite;
		private var fields:Array;
		private var textfields:Array;
		private var defaultText:Array;
		private var statusMessages:Array;
		private var redLines:Array;
		private var statusTimer:Timer;
		private var crtIndex:Number;
		private var url:URLRequest;
		private var urlVar:URLVariables;
		private var loader:URLLoader;
		private var defaultTextHtml:Array;
		private var phpScript:String;
		private var titles:Array;
		private var cssData:String;
		private var style:StyleSheet;
		private var xml:XMLList;
		private var fieldsRollOverColor:Number;
		private var fieldsRollOutColor:Number;
		
		//constructor
		public function ContactInfo(a:XMLList, cData:String, substractHeight:Number) 
		{
			xml = a;
			style = new StyleSheet();
			style.parseCSS(cData);
			
			fieldsRollOutColor = Number(xml.fieldsRollOutColor.text());
			fieldsRollOverColor = Number(xml.fieldsRollOverColor.text());
			phpScript = (xml.phpScript.text());
			
			Title.styleSheet = style;
			Title.autoSize = TextFieldAutoSize.LEFT;
			Title.condenseWhite = true;
			Title.htmlText = a.contactTitle.text();
			
			Description.x = nameBody.x + nameBody.width + 28;
			Description.y = nameBody.y;
			Description.styleSheet = style;
			Description.condenseWhite = true;
			Description.htmlText = a.contactDescription.text();
			
			Description.width = Number(xml.cubeWidth.text()) - nameBody.width - 70;
			Description.height = Number(xml.cubeHeight.text()) - substractHeight - nameBody.y;
			
			
			fields  = new Array();
			textfields = new Array();
			defaultText = new Array();
			defaultTextHtml = new Array();
			redLines = new Array();
			statusMessages = new Array();
			titles = new Array();
			
			statusTimer = new Timer(Number(xml.statusTextDelay.text())*1000, 1);
			statusTimer.addEventListener(TimerEvent.TIMER, onStatusTimer);
			
			statusMessages.push(xml.errorName.text());
			statusMessages.push(xml.errorEmail.text());
			statusMessages.push(xml.errorSubject.text());
			statusMessages.push(xml.errorMessage.text());
			statusMessages.push(xml.isSendingMessage.text());
			statusMessages.push(xml.errorNotSent.text());
			statusMessages.push(xml.emailSentSuccess.text());
			
			fields.push(nameBody);
			fields.push(mailBody);
			fields.push(subjectBody);
			fields.push(messageBody);
			
			sendButton.setData(xml.sendButtonText.text(), Number(xml.sendButtonTextColor.text()), cData);
			sendButton.addEventListener(MouseEvent.CLICK, validateAndSendMail);
			sendButton.addEventListener(ParamEvent.UPDATEREFLECTION, updRef);
			
			nameRedLine = nameBody["redLine"]; nameRedLine.alpha = 0; redLines.push(nameRedLine);
			mailRedLine = mailBody["redLine"]; mailRedLine.alpha = 0; redLines.push(mailRedLine);
			subjectRedLine = subjectBody["redLine"]; subjectRedLine.alpha = 0; redLines.push(subjectRedLine);
			messageRedLine = messageBody["redLine"]; messageRedLine.alpha = 0; redLines.push(messageRedLine);
			
			nameOverState = nameBody["overState"]; nameOverState.alpha = 0;
			mailOverState = mailBody["overState"]; mailOverState.alpha = 0;
			subjectOverState = subjectBody["overState"]; subjectOverState.alpha = 0;
			messageOverState = messageBody["overState"]; messageOverState.alpha = 0;
			
			nameText = nameBody["Text"];
			nameText.htmlText = xml.nameFieldDefaultText.text();
			textfields.push(nameText);
			defaultText.push(nameText.text);
			defaultTextHtml.push(xml.nameFieldDefaultText.text());
			
			emailText = mailBody["Text"];
			emailText.htmlText = xml.emailFieldDefaultText.text();
			textfields.push(emailText);
			defaultText.push(emailText.text);
			defaultTextHtml.push(xml.emailFieldDefaultText.text());
			
			subjectText = subjectBody["Text"];
			subjectText.htmlText = xml.subjectFieldDefaultText.text();
			textfields.push(subjectText);
			defaultText.push(subjectText.text);
			defaultTextHtml.push(xml.subjectFieldDefaultText.text());
			
			messageText = messageBody["Text"];
			messageText.htmlText = xml.messageFieldDefaultText.text();
			textfields.push(messageText);
			defaultText.push(messageText.text);
			defaultTextHtml.push(xml.messageFieldDefaultText.text());
			
			statusBox.autoSize = "left";
			statusBox.styleSheet = style;
			statusBox.alpha = 0;
			
			for (var i:int = 0; i < textfields.length; i++) 
			{
				Tweener.addTween(textfields[i], { _color:fieldsRollOutColor, time: 0.1, transition: "easeoutquad" });
			}
			
			addFocusEvents();
		}
		
		//update the reflection
		private function updRef(e:ParamEvent):void 
		{
			updateReflectionEvent();
		}
		
		//add focus events (focus in and out) for the fields 
		private function addFocusEvents():void
		{
			nameBody.addEventListener(FocusEvent.FOCUS_IN, onFocusIn_Handler);
			nameBody.addEventListener(FocusEvent.FOCUS_OUT, onFocusOut_Handler);
			mailBody.addEventListener(FocusEvent.FOCUS_IN, onFocusIn_Handler);
			mailBody.addEventListener(FocusEvent.FOCUS_OUT, onFocusOut_Handler);
			subjectBody.addEventListener(FocusEvent.FOCUS_IN, onFocusIn_Handler);
			subjectBody.addEventListener(FocusEvent.FOCUS_OUT, onFocusOut_Handler);
			messageBody.addEventListener(FocusEvent.FOCUS_IN, onFocusIn_Handler);
			messageBody.addEventListener(FocusEvent.FOCUS_OUT, onFocusOut_Handler);
		}
		
		//handler for the focus in event
		private function onFocusIn_Handler(e:FocusEvent):void 
		{	
			var crtField:Number = fields.indexOf(e.currentTarget);
			Tweener.addTween(e.currentTarget.overState, { alpha:1, time: 0.3, transition: "easeoutquad" } );
			Tweener.addTween(e.currentTarget.Text, { _color:fieldsRollOverColor, time: 0.3, transition: "easeoutquad" });
			if (textfields[crtField].text == defaultText[crtField]) textfields[crtField].htmlText = "";	
		}
		
		//handler for the focus out event
		private function onFocusOut_Handler(e:FocusEvent):void 
		{	
			var crtField:Number = fields.indexOf(e.currentTarget);
			Tweener.addTween(e.currentTarget.overState, { alpha:0, time: 0.3, transition: "easeoutquad" } );
			
			if (StringUtil.isBlank(textfields[crtField].text)) 	textfields[crtField].htmlText = defaultTextHtml[crtField];
			if (textfields[crtField].text == defaultText[crtField]) Tweener.addTween(e.currentTarget.Text, { _color:fieldsRollOutColor, time: 0.3,onComplete:updateReflectionEvent, transition: "easeoutquad" })
			
			updateReflectionEvent();
		}
		
		//dispatch the custom event
		private function updateReflectionEvent():void
		{
			var customEvent:ParamEvent = new ParamEvent("updatereflection", {variable:null});
			dispatchEvent(customEvent);
		}
		
		//validate fields and send the mail if everything is ok
		private function validateAndSendMail(e:MouseEvent):void
		{
			disableTextFields();
			if (textfields[0].text == defaultText[0]||StringUtil.isBlank(textfields[0].text))
				{
				changeStatusText(statusMessages[0],0);
				enableTextFields();
				}
			else if (textfields[1].text == defaultText[1]||StringUtil.isBlank(textfields[1].text)||(!StringUtil.isEmail(textfields[1].text)))
				{ 
				changeStatusText(statusMessages[1],1);
				enableTextFields();
				}
			else if (textfields[2].text == defaultText[2]||StringUtil.isBlank(textfields[2].text))
				{ 
				changeStatusText(statusMessages[2],2);
				enableTextFields();
				}
			else if (textfields[3].text == defaultText[3]||StringUtil.isBlank(textfields[3].text))
				{ 
				changeStatusText(statusMessages[3],3);
				enableTextFields();
				}
			
			else
			{
				send();		
			}
			
		}
		
		//disable the text fields (type:dynamic)
		private function disableTextFields():void
		{
			for (var i:Number = 0; i <= 3; i++)
			{
			textfields[i].type = TextFieldType.DYNAMIC;
			}
			
		}
		
		//enable the text fields (type:input)
		private function enableTextFields():void
		{
			
			for (var i:Number = 0; i <= 3; i++)
			{
			textfields[i].type = TextFieldType.INPUT;
			redLines[i].alpha = 0;
			}
		}
		
		//change status box text
		private function changeStatusText(message:String,idx:Number):void
		{
			Tweener.addTween(statusBox, { alpha:1, time: 0.3, onUpdate:updateReflectionEvent, transition: "easeoutquad" });
			statusBox.htmlText = message;
			crtIndex = idx;
			if (crtIndex > -1)
			{
				Tweener.addTween(redLines[crtIndex], { alpha:1, time: 0.3, transition: "easeoutquad" });
			}
			
			statusTimer.start();
		}
		
		//status timer complete
		private function onStatusTimer(e:TimerEvent):void 
		{
			Tweener.addTween(redLines[crtIndex], { alpha:0, time: 0.3, transition: "easeoutquad" } ); 
			
			Tweener.addTween(statusBox, { alpha:0, time: 0.3, onUpdate:updateReflectionEvent, transition: "easeoutquad" } );
			statusTimer.stop();
		}
		
		//send the mail through php
		private function send():void
		{
		
			statusBox.htmlText = statusMessages[4];
			url = new URLRequest(phpScript);
			
			url.method = URLRequestMethod.POST;
			
			urlVar = new URLVariables();
			urlVar.sender_email = emailText.text;
			urlVar.sender_message = messageText.text;
			urlVar.sender_subject = subjectText.text;
			urlVar.sender_name = nameText.text;
			
			url.data = urlVar;
			
			loader = new URLLoader(url);
			loader.addEventListener(Event.COMPLETE, loader_CompleteHandler, false, 0, true);
			loader.addEventListener(IOErrorEvent.IO_ERROR, loader_IoError, false, 0, true);
			loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, security_error, false, 0, true);
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			loader.load(url);
		}
		
		
		//treats the security error, if any
		private function security_error(e:SecurityErrorEvent):void 
		{
			trace(e.toString());
			//statusText.htmlText = e.toString();
		}
		
		//treats the IO error, if any
		private function loader_IoError(e:IOErrorEvent):void 
		{
			trace(e.toString());
		}
		
		//handler for the php load complete event
		private function loader_CompleteHandler(e:Event):void 
		{
			var xmlVar:XML = new XML(loader.data);
			if (xmlVar.message.text() == "sent")
			{
				changeStatusText(statusMessages[6], -1);
				
				resetFields();		
			}
			else 
			{
				changeStatusText(statusMessages[5], -1)
				
				enableTextFields();
			}
		}
		
		//re-initialize the fields
		private function resetFields():void
		{
			
			for (var i:Number = 0; i <= 3; i++)
			{
			textfields[i].htmlText = defaultTextHtml[i];
			textfields[i].type = TextFieldType.INPUT;
			Tweener.addTween(textfields[i], { _color:fieldsRollOutColor, time: 0.3, transition: "easeoutquad" });
			}
		}
		
	}

}