package  com.oxylusflash.comingSoon
{
	//import the classes
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import com.oxylusflash.util.Global;
	import com.oxylusflash.zorked.URLNavigator;
	import caurina.transitions.Tweener;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.net.URLRequest;
	import com.oxylusflash.ui.VerticalScrollbar;
	import com.oxylusflash.events.ScrollbarEvent;
	import flash.text.StyleSheet;
	import flash.text.TextFieldAutoSize;
	import com.oxylusflash.events.ParamEvent;
	import com.oxylusflash.util.Global;
	
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	
	 
	public class ContactModule extends Sprite
	{
		//declaring variables
		private var xml:XML;
		private var moduleWidth:Number;
		private var moduleHeight:Number;
		private var cssData:String;
		private var logoLink:String;
		private var logoTarget:String;
		private var logoPath:String;
		private var mainBg:MainBackground;
		private var navButtonsRollOutColor:Number;
		private var navButtonsRollOverColor:Number;
		private var bmp:BitmapData;
		private var LogoHolder:Sprite;
		private var logoLoader:Loader;
		public var scrollComponent:VerticalScrollbar;
		private var style:StyleSheet;
		private var aboutDescriptionY:Number;
		private var aboutDescription:AboutDescription;
		private var navButtons:NavButtons;
		private var scaleMatrix:Matrix;
		private var reflection:Bitmap;
		private var homeModuleName:String;
		private var reflectionMask:ReflectionMask;
		private var bigBmp:BitmapData;
		private var moduleScaleMatrix:Matrix;
		public var moduleBmp:Bitmap;
		private var ow:Number;
		private var oh:Number;
			
		//constructor
		public function ContactModule(a:XML) 
		{
			this.blendMode = BlendMode.LAYER;
			addEventListener(Event.ADDED_TO_STAGE , ats);
			xml = new XML(a);
		}
		
		//added to stage handler
		private function ats(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, ats);
			moduleWidth = Number(xml.settings.cubeWidth.text());
			moduleHeight = Number(xml.settings.cubeHeight.text());
			
			homeModuleName = xml.settings.homeModuleName.text();
			
			navButtonsRollOutColor  = Number(xml.settings.navButtonsRollOutColor.text());
			navButtonsRollOverColor  = Number(xml.settings.navButtonsRollOverColor.text());
			logoPath = xml.settings.logoPath.text();
			logoLink = xml.settings.logoLink.text();
			logoTarget = xml.settings.logoTarget.text();
			
			mainBg = MainBackground(addChild(new MainBackground()));
			mainBg.resizeSmall(moduleWidth, moduleHeight);
			
			cssData = xml.settings.cssData.text();
			style = new StyleSheet();
			style.parseCSS(cssData);
			
			loadLogo();
			
			addNavButtons();
			addReflectionMask();
			addContactInfo();
		}
		
		
		
		//load the logo
		private function loadLogo():void
		{
			logoLoader = new Loader();
			logoLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, addLogo);
			logoLoader.load(new URLRequest(logoPath)); 
		}
		
		//add the logo
		private function addLogo(e:Event):void 
		{
			ow = logoLoader.content.width;
			oh = logoLoader.content.height;
			bmp = new BitmapData(ow, oh, true, 0);
			bmp.draw(logoLoader.content);
			LogoHolder = new Sprite();
			addChild(LogoHolder);
			LogoHolder.tabEnabled = false;
			LogoHolder.tabChildren = false;
			LogoHolder.alpha = 0;
			LogoHolder.addChild(new Bitmap(bmp, "auto", true ));
			resizeLogoHolder();
		}
		
		//resize the logo holder
		private function resizeLogoHolder():void
		{
			LogoHolder.height = Math.round(mainBg.blackGradient.height - 6);
			LogoHolder.width = Math.round(ow / (oh / LogoHolder.height));
			LogoHolder.x = Math.round(mainBg.blackGradient.width / 2 - LogoHolder.width / 2);
			LogoHolder.y = Math.round(mainBg.blackGradient.height / 2 - LogoHolder.height / 2);
			Tweener.addTween(LogoHolder, { alpha:1, time: 0.3,onComplete:updateReflection, transition: "easeoutquad" } );
			//Global.logo = LogoHolder;
			LogoHolder.buttonMode = true;
			LogoHolder.addEventListener(MouseEvent.CLICK, onLogoClick);
		}
		
		//handler for the logo click event
		private function onLogoClick(e:MouseEvent):void 
		{
			if (logoLink > "") URLNavigator.ChangePage(logoLink, logoTarget || "_blank");
		}
		
		//add the navigation buttons
		private function addNavButtons():void
		{
			navButtons = NavButtons(addChild (new NavButtons(homeModuleName, "", moduleWidth, navButtonsRollOutColor, navButtonsRollOverColor, "right")));
			navButtons.addEventListener(ParamEvent.BUTTONCLICK, onBtnClick);
			navButtons.addEventListener(ParamEvent.UPDATEREFLECTION, updateRef);
			navButtons.y = Math.round(moduleHeight - navButtons.height - 2)
			navButtons.x = 1;
		}
		
		//update the reflection  - called by a custom event
		private function updateRef(e:ParamEvent):void 
		{
			updateReflection()
		}
		
		//handler for the navigation button click event
		private function onBtnClick(e:ParamEvent):void 
		{
			var customEvent:ParamEvent = new ParamEvent("rotatecube", {variable:e.params.variable});
			dispatchEvent(customEvent);
		}
		
		//add the contact info
		private function addContactInfo():void
		{
			var contactInfo:ContactInfo = ContactInfo(addChild (new ContactInfo(xml.settings, cssData, mainBg.blackGradient.height + 25 + navButtons.height)));
			contactInfo.addEventListener(ParamEvent.UPDATEREFLECTION, updRef);
			contactInfo.y = mainBg.blackGradient.height + 25;
			contactInfo.x = 30;
			updateReflection();
		}
		
		//update reflection - called by a custom event
		private function updRef(e:ParamEvent):void 
		{
			updateReflection()
		}
		
		//add the reflection mask
		private function addReflectionMask():void
		{
			reflectionMask = new ReflectionMask();
			reflectionMask.visible = false;
			addChild(reflectionMask);
			reflectionMask.cacheAsBitmap = true;
			reflectionMask.y = moduleHeight + Global.reflectionDistance;
			reflectionMask.width = moduleWidth;
			reflectionMask.height = Global.reflectionHeight;
		}
		
		//update the reflection and the module bitmap material
		public function updateReflection():void
		{
			
			if (reflection)
			{
				removeChild(reflection);
				reflection = null;
			}
			scaleMatrix = new Matrix();
			scaleMatrix.scale(1, 1); 
			bmp = new BitmapData(moduleWidth, moduleHeight, true, 0xffffff);
			bmp.draw(this, scaleMatrix);
			reflection = new Bitmap(bmp,"auto",true);
			addChild(reflection);
			reflection.scaleY = -1;
			reflection.y =  2 * moduleHeight + Global.reflectionDistance;
		
			
			reflection.alpha = Global.reflectionAlpha;
			reflection.cacheAsBitmap = true;
			
			reflection.mask = reflectionMask;
			
			
			moduleScaleMatrix = new Matrix();
			moduleScaleMatrix.scale(1, 1);
			bigBmp = new BitmapData(moduleWidth, moduleHeight + Global.reflectionDistance + Global.reflectionHeight, true, 0x000000);
			bigBmp.draw(this, moduleScaleMatrix)
			moduleBmp = new Bitmap(bigBmp, "auto", true);
			
			var customEvent:ParamEvent = new ParamEvent("updatematerial", {variable:"right"});
			dispatchEvent(customEvent);
		}
	}

}