﻿package  com.oxylusflash.comingSoon
{
	//importing classes
	import flash.display.Sprite;
	import flash.events.TimerEvent;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import flash.utils.Timer;
	import com.oxylusflash.events.ParamEvent;
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	
	public class CountDownTimer extends Sprite
	{
		//declaring variables
		public var statusText:TextField;
		public var daysLeft:TextField;
		public var hoursLeft:TextField;
		public var minutesLeft:TextField;
		public var secondsLeft:TextField;
		public var daysTitle:TextField;
		public var hoursTitle:TextField;
		public var minutesTitle:TextField;
		public var secondsTitle:TextField;
		private var sheet:StyleSheet;
		private var endDate:Date;
		private var countdownTimer:Timer;
		private var now:Date;
		private var timeLeft:Number;
		private var seconds:Number;
		private var minutes:Number;
		private var hours:Number;
		private var days:Number;
		private var sec:String;
		private var min:String;
		private var hrs:String;
		private var d:String;
		
		//constructor with parameters
		public function CountDownTimer(cData:String,cdText:String,cdFinishText:String,cdDate:String,cdDaysText:String,cdHoursText:String,cdMinutesText:String,cdSecondsText:String) 
		{
			sheet = new StyleSheet();
			sheet.parseCSS(cData);
			var countDownFinishText:String = cdFinishText;
			var countDownDate:String = cdDate;
			
			var subTextFields:Array = new Array();
			subTextFields.push(cdDaysText);
			subTextFields.push(cdHoursText);
			subTextFields.push(cdMinutesText);
			subTextFields.push(cdSecondsText);
			
			statusText.styleSheet = sheet;
			statusText.htmlText = cdText;
			
			daysTitle.htmlText = cdDaysText;
			hoursTitle.htmlText = cdHoursText;
			minutesTitle.htmlText = cdMinutesText;
			secondsTitle.htmlText = cdSecondsText;
			
			var dateArray:Array = new Array();
			dateArray = cdDate.split(",");
			var year:Number = Number(dateArray[0]);
			var month:Number = Number(dateArray[1]);
			var day:Number = Number(dateArray[2]);
		
			endDate = new Date(year, month, day);
			
			var now:Date = new Date();
			var timeLeft:Number = endDate.getTime() - now.getTime();
			
			if (Number(endDate.getTime() - (new Date()).getTime()) > 0)
			{
				updateTime(null);
				countdownTimer = new Timer(1000);
				countdownTimer.addEventListener(TimerEvent.TIMER, updateTime);
				countdownTimer.start();
			}
			else
			{
				statusText.htmlText = cdFinishText;
			}
		}
		
		//update the time fields
		private function updateTime(e:TimerEvent):void
		{
			
			now = new Date();
			timeLeft = endDate.getTime() - now.getTime();
			
			seconds = Math.floor(timeLeft / 1000);
			minutes = Math.floor(seconds / 60);
			hours = Math.floor(minutes / 60);
			days = Math.floor(hours / 24);
			
			seconds %= 60;
			minutes %= 60;
			hours %= 24;

			sec = seconds.toString(); if (seconds < 10)  (sec = "0" + sec);
			min = minutes.toString(); if (minutes < 10)  (min = "0" + min);
			hrs = hours.toString(); if (hours < 10)  (hrs = "0" + hrs);
			d = days.toString(); if (days < 10)  (d = "0" + d);
			
			daysLeft.htmlText = d;
			hoursLeft.htmlText = hrs;
			minutesLeft.htmlText = min;
			secondsLeft.htmlText = sec;
			
			var customEvent:ParamEvent = new ParamEvent("updatereflection", {variable:null});
			dispatchEvent(customEvent);
		}
		
	}

}