package  com.oxylusflash.comingSoon
{
	//importing classes
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.net.URLRequest;
	import caurina.transitions.Tweener;
	import com.oxylusflash.zorked.URLNavigator;
	import com.oxylusflash.util.Global;
	import com.oxylusflash.events.ParamEvent;
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	public class HomeModule extends Sprite
	{
		//declaring variables
		private var xml:XML;
		private var cssData:String;
		private var countDownVisible:Boolean;
		private var countDownText:String;
		private var countDownCompleteText:String;
		private var countDownDate:String;
		private var countDownDaysText:String;
		private var countDownHoursText:String;
		private var countDownMinutesText:String;
		private var countDownSecondsText:String;
		private var bmp:BitmapData;
		private var LogoHolder:Sprite;
		private var logoLoader:Loader;
		private var logoPath:String;
		private var logoLink:String;
		private var logoTarget:String;
		private var moduleHeight:Number;
		private var moduleWidth:Number;
		private var countDownHolder:CountDownHolder;
		private var countDownTimer:CountDownTimer;
		private var navButtonsRollOutColor:Number;
		private var navButtonsRollOverColor:Number;
		private var mainBg:MainBackground;
		private var reflection:Bitmap;
		private var scaleMatrix:Matrix;
		private var aboutModuleName:String;
		private var contactModuleName:String;
		private var reflectionMask:ReflectionMask;
		private var bigBmp:BitmapData;
		private var moduleScaleMatrix:Matrix;
		public var moduleBmp:Bitmap;
		
		
		//constructor
		public function HomeModule(a:XML) 
		{
			this.blendMode = BlendMode.LAYER;
			addEventListener(Event.ADDED_TO_STAGE , ats);
			xml = new XML(a);
		}
		
		//added to stage event handler
		private function ats(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, ats);
			moduleWidth = xml.settings.cubeWidth.text();
			moduleHeight = xml.settings.cubeHeight.text();
			
			aboutModuleName = xml.settings.aboutModuleName.text();
			contactModuleName = xml.settings.contactModuleName.text();
			
			mainBg = MainBackground(addChild(new MainBackground()));
			mainBg.resize(moduleWidth, moduleHeight);
			
			cssData = xml.settings.cssData.text();
			logoPath = xml.settings.logoPath.text();
			logoLink = xml.settings.logoLink.text();
			logoTarget = xml.settings.logoTarget.text();
			countDownVisible = (xml.settings.countDownVisible.text() == "true");
			countDownText = (xml.settings.countDownText.text());
			countDownCompleteText = (xml.settings.countDownCompleteText.text());
			countDownDate = (xml.settings.countDownDate.text());
			countDownDaysText = (xml.settings.countDownDaysText.text());
			countDownHoursText = (xml.settings.countDownHoursText.text());
			countDownMinutesText = (xml.settings.countDownMinutesText.text());
			countDownSecondsText = (xml.settings.countDownSecondsText.text());
			navButtonsRollOutColor  = Number(xml.settings.navButtonsRollOutColor.text());
			navButtonsRollOverColor  = Number(xml.settings.navButtonsRollOverColor.text());
			
			
			if (countDownVisible)
			{
				countDownHolder = CountDownHolder(addChild (new CountDownHolder()));
				countDownHolder["background"].width = moduleWidth-2;
				countDownHolder.y = mainBg.blackGradient.height;
				countDownHolder.x = 1;
				countDownTimer  = CountDownTimer(countDownHolder.addChild (new CountDownTimer(cssData, countDownText, countDownCompleteText, countDownDate, countDownDaysText, countDownHoursText, countDownMinutesText, countDownSecondsText)));
				countDownTimer.addEventListener(ParamEvent.UPDATEREFLECTION , updateRef);
				countDownTimer.x = Math.round(countDownHolder.width / 2 - countDownTimer.width / 2);

			}
			else
			{
				mainBg.resizeNoTimer(moduleWidth, moduleHeight);
			}
			
			
			loadLogo();
			addSocialLinks();
			addNavButtons();
			addReflectionMask();
			updateReflection();
		}
		
		
		
		
		
		//load the logo
		private function loadLogo():void
		{
			logoLoader = new Loader();
			logoLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, addLogo);
			logoLoader.load(new URLRequest(logoPath)); 
		}
		
		//add the logo
		private function addLogo(e:Event):void 
		{
			var ow:Number = logoLoader.content.width;
			var oh:Number = logoLoader.content.height;
			bmp = new BitmapData(ow, oh, true, 0);
			bmp.draw(logoLoader.content);
			LogoHolder = new Sprite();
			addChild(LogoHolder);
			LogoHolder.tabEnabled = false;
			LogoHolder.tabChildren = false;
			LogoHolder.alpha = 0;
			LogoHolder.addChild(new Bitmap(bmp, "auto", true ));
			LogoHolder.x = Math.round(mainBg.blackGradient.width / 2 - LogoHolder.width / 2);
			LogoHolder.y = Math.round(mainBg.blackGradient.height / 2 - LogoHolder.height / 2);
			Tweener.addTween(LogoHolder, { alpha:1, time: 0.3, onComplete:updateReflection, transition: "easeoutquad" } );
			Global.logo = LogoHolder;
			LogoHolder.buttonMode = true;
			LogoHolder.addEventListener(MouseEvent.CLICK, onLogoClick);
			var customEvent:ParamEvent = new ParamEvent("logoloaded", {variable:null});
			dispatchEvent(customEvent);
			
			
		}
		
		//handler for the logo click event
		private function onLogoClick(e:MouseEvent):void 
		{
			if (logoLink > "") URLNavigator.ChangePage(logoLink, logoTarget || "_blank");
		}
		
		//add the social links holder
		private function addSocialLinks():void
		{
			var socialLinksHolder:SocialLinksHolder = new SocialLinksHolder(cssData, xml.settings);
			socialLinksHolder.addEventListener(ParamEvent.UPDATEREFLECTION, updateRef);
			addChild(socialLinksHolder);
		
			var socialLinkIconWidth:Number = Number(xml.settings.socialLinkIconWidth.text());
			var socialLinkIconHeight:Number = Number(xml.settings.socialLinkIconHeight.text());
			var socialLinksHorizontalSpacing:Number = Number(xml.settings.socialLinksHorizontalSpacing.text());
	
			socialLinksHolder.x = Math.round(mainBg.blackGradient.width / 2 - socialLinksHolder.width / 2);
			socialLinksHolder.setTextWidth(socialLinksHolder.x, mainBg.blackGradient.width)
			if (countDownHolder) socialLinksHolder.y = Math.round(countDownHolder.y + countDownHolder.height) + 10
			else socialLinksHolder.y = Math.round(mainBg.whiteGradient.y + mainBg.whiteGradient.height / 2 - socialLinksHolder.height-25);
			
		}
		
		//update the reflection  - called by a custom event
		private function updateRef(e:ParamEvent):void 
		{
			updateReflection()
		}
		
		//add the navigation buttons
		private function addNavButtons():void
		{
			var navButtons:NavButtons = NavButtons(addChild (new NavButtons(aboutModuleName, contactModuleName, moduleWidth, navButtonsRollOutColor, navButtonsRollOverColor)));
			navButtons.addEventListener(ParamEvent.BUTTONCLICK, onBtnClick);
			navButtons.addEventListener(ParamEvent.UPDATEREFLECTION, updateRef);
			navButtons.y = Math.round(moduleHeight - navButtons.height - 2)
			navButtons.x = 1;
		}
		
		//click handler for the navigation buttons
		private function onBtnClick(e:ParamEvent):void 
		{
			var customEvent:ParamEvent = new ParamEvent("rotatecube", {variable:e.params.variable});
			dispatchEvent(customEvent);
		}
		
		//add the reflection mask
		private function addReflectionMask():void
		{
			reflectionMask = new ReflectionMask();
			reflectionMask.visible = false;
			addChild(reflectionMask);
			reflectionMask.cacheAsBitmap = true;
			reflectionMask.y = moduleHeight + Global.reflectionDistance;
			reflectionMask.width = moduleWidth;
			reflectionMask.height = Global.reflectionHeight;
		}
		
		//update the reflection and the module bitmap material
		public function updateReflection():void
		{
			
			if (reflection)
			{
				removeChild(reflection);
				reflection = null;
			}
			scaleMatrix = new Matrix();
			scaleMatrix.scale(1,1); 
			bmp = new BitmapData(moduleWidth, moduleHeight, true, 0xffffff);
			bmp.draw(this, scaleMatrix);
			reflection = new Bitmap(bmp,"auto",true);
			addChild(reflection);
			reflection.scaleY = -1;
			reflection.y =  2 * moduleHeight + Global.reflectionDistance;
			
			reflection.alpha = Global.reflectionAlpha;
			reflection.cacheAsBitmap = true;
			
			reflection.mask = reflectionMask;
			
			moduleScaleMatrix = new Matrix();
			moduleScaleMatrix.scale(1, 1);
			bigBmp = new BitmapData(moduleWidth, moduleHeight + Global.reflectionDistance + Global.reflectionHeight, true, 0x000000);
			
			bigBmp.draw(this, moduleScaleMatrix)
			moduleBmp = new Bitmap(bigBmp, "auto", true);
			
			var customEvent:ParamEvent = new ParamEvent("updatematerial", {variable:"front"});
			dispatchEvent(customEvent);
		}
	}

}