package com.oxylusflash.comingSoon
{
	//importing classes
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Loader;
	import flash.display.Scene;
	import flash.display.Sprite
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.filters.BlurFilter;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import caurina.transitions.Tweener;
	import flash.utils.Timer;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.objects.*;
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.render.*;
	import org.papervision3d.events.InteractiveScene3DEvent;
	import org.papervision3d.core.utils.*;
	import org.papervision3d.view.Viewport3D;
	import com.oxylusflash.events.ParamEvent;
	import com.oxylusflash.util.Global;
	
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	
	public class Main extends Sprite
	{
		//declaring variables
		public var upGradient:Sprite;
		public var downGradient:Sprite;
		public var preloader:Preloader;
		private var xml:XML;
		private var cubeWidth:Number;
		private var cubeHeight:Number;
		private var xmlLoader:URLLoader;
		private var cssData:String;
		private var renderEngine:BasicRenderEngine;
		private var scene3d:Scene3D;
		private var camera3d:Camera3D;
		private var viewPort3D:Viewport3D;
		private var cube:Cube;
		private var homemodule:HomeModule;
		private var aboutmodule:AboutModule;
		private var contactmodule:ContactModule;
		private var rotY:Number = 0;
		private var crtModule:Number = 1; 
		private var transitionType:String;
		private var transitionTime:Number;
		
		//constructor
		public function Main()
		{
			addEventListener(Event.ADDED_TO_STAGE , ats);
		}
		
		//added to stage handler
		private function ats(e:Event):void 
		{
			preloader.x = Math.round(stage.stageWidth / 2);
			preloader.y = Math.round(stage.stageHeight / 2);
			preloader.alpha = 0;
			Tweener.addTween(preloader, { alpha:1, time: 0.3, transition: "easeinquad" });
			this.blendMode = BlendMode.LAYER;
			upGradient.cacheAsBitmap = true;
			downGradient.cacheAsBitmap = true;
			removeEventListener(Event.ADDED_TO_STAGE, ats);
			stage.addEventListener(Event.RESIZE, onResize);
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			loadXmlFile(stage.loaderInfo.parameters.xmlFile || "data.xml");
			onResize(null);
		}
		
		//resize handler
		private function onResize(e:Event):void 
		{
			upGradient.width = Math.round(stage.stageWidth);
			upGradient.height = Math.round(stage.stageHeight / 2);
			downGradient.y = upGradient.height;
			downGradient.width = Math.round(stage.stageWidth);
			downGradient.height = Math.round(stage.stageHeight / 2);
			try 
			{
				preloader.x = Math.round(stage.stageWidth / 2);
				preloader.y = Math.round(stage.stageHeight / 2);
			}
			catch (er:Error) { }
			try 
			{
				aboutmodule.x = Math.round(stage.stageWidth / 2 - cubeWidth / 2);
				aboutmodule.y = Math.round(stage.stageHeight / 2 - cubeHeight / 2);
			}
			catch (er:Error) { }
			try 
			{
				homemodule.x = Math.round(stage.stageWidth / 2 - cubeWidth / 2);
				homemodule.y = Math.round(stage.stageHeight / 2 - cubeHeight / 2);
			}
			catch (er:Error) { }
			try 
			{
				contactmodule.x = Math.round(stage.stageWidth / 2 - cubeWidth / 2);
				contactmodule.y = Math.round(stage.stageHeight / 2 - cubeHeight / 2);
			}
			catch (er:Error) { }
		}
		
		//load the xml file
		public function loadXmlFile(path:String):void
		{			
			xmlLoader = new URLLoader;
			xmlLoader.addEventListener(Event.COMPLETE, xmlLoader_completeHandler);
			xmlLoader.load(new URLRequest(path));
		}	
		
		//handler for the xml load complete event
		private function xmlLoader_completeHandler(event:Event):void
		{
			xml = new XML(event.target.data); 
			cubeWidth = Number(xml.settings.cubeWidth.text());
			cubeHeight  = Number(xml.settings.cubeHeight.text());
			
			transitionTime = Number(xml.settings.transitionTime.text());
			transitionType = xml.settings.transitionType.text();
			
			Global.reflectionVisible = (xml.settings.reflectionVisible.text() == "true");
			Global.reflectionDistance = Number(xml.settings.reflectionDistance.text());
			Global.reflectionHeight = Number(xml.settings.reflectionHeight.text());
			Global.reflectionAlpha = Number(xml.settings.reflectionAlpha.text());
		
			
			if (Global.reflectionVisible == false)
			{
				Global.reflectionDistance = 0;
				Global.reflectionHeight = 0;
				Global.reflectionAlpha = 0;
			}
			
			cssData = xml.settings.cssData.text();
			
			
			viewPort3D = new Viewport3D(0,0,true,false);
			addChild(viewPort3D);
			
			viewPort3D.cacheAsBitmap = true;
			
			renderEngine  = new BasicRenderEngine();
			
			scene3d  = new Scene3D();
			
			camera3d = new Camera3D();
			
			camera3d.focus = Math.abs(camera3d.z / camera3d.zoom);
			
			addHomeModule();
			addAboutModule();
			addContactModule();
			buildCube();
			
		}
			
		
		
		
		
		//remove the preloader
		private function removePreloader():void
		{
			
			removeChild(preloader);
			preloader  = null;
			Tweener.addTween(homemodule, { alpha:1, time: 0.5, transition: "easeoutquad" });
			
			
		}
		
		//update cube materials
		private function updateMaterial(e:ParamEvent):void
		{
			try 
			{
			
				switch (e.params.variable)
				{
					case "right":
					{
						cube.materials.getMaterialByName("left").bitmap = contactmodule.moduleBmp.bitmapData;
						renderCube();
						break;
					}
					case "front":
					{
						cube.materials.getMaterialByName("front").bitmap = homemodule.moduleBmp.bitmapData;
						renderCube();
						break;
					}
					case "left":
					{
						cube.materials.getMaterialByName("right").bitmap = aboutmodule.moduleBmp.bitmapData;
						renderCube();
						break;
					}
				}
				
			}
			
			catch (er:Error) { }	
			
		}
		
		
		
		//rotate the cube left or right - called by a custom event
		private function rotateCube(e:ParamEvent):void 
		{
			homemodule.visible = false;
			aboutmodule.visible = false;
			contactmodule.visible = false;
			cube.visible = true;
			
			switch(e.params.variable)
			{
				case "leftButton":
				{
					crtModule--;
					rotateLeft();
					break;
				}
				
				case "rightButton":
				{
					crtModule++;
					rotateRight();
					break;
				}
			}
		}
		
		//add the home module and its custom events
		private function addHomeModule():void
		{
			homemodule = new HomeModule(xml);
			
			homemodule.addEventListener(ParamEvent.UPDATEMATERIAL, updateMaterial);
			homemodule.addEventListener(ParamEvent.ROTATECUBE, rotateCube);
			homemodule.addEventListener(ParamEvent.LOGOLOADED, logoLoaded);
			homemodule.x = Math.round(stage.stageWidth / 2 - cubeWidth / 2);
			homemodule.y = Math.round(stage.stageHeight / 2 - cubeHeight / 2); 
			homemodule.alpha = 0;
			addChild(homemodule);
			
			homemodule.cacheAsBitmap = true;
			//homemodule.visible = false;
		}
		
		private function logoLoaded(e:ParamEvent):void 
		{
			Tweener.addTween(preloader, { alpha:0, time: 0.2, onComplete:removePreloader, transition: "easeoutquart" });
		}
		
		//add the about module and its custom events
		private function addAboutModule():void
		{
			aboutmodule = new AboutModule(xml);
			aboutmodule.addEventListener(ParamEvent.UPDATEMATERIAL, updateMaterial);
			aboutmodule.addEventListener(ParamEvent.ROTATECUBE, rotateCube);
			aboutmodule.x = Math.round(stage.stageWidth / 2 - cubeWidth / 2);
			aboutmodule.y = Math.round(stage.stageHeight / 2 - cubeHeight / 2);
			addChild(aboutmodule);
			aboutmodule.cacheAsBitmap = true;
			aboutmodule.visible = false;
		}
		
		//add the contact module and its custom events
		private function addContactModule():void
		{
			contactmodule = new ContactModule(xml);
			contactmodule.addEventListener(ParamEvent.UPDATEMATERIAL, updateMaterial);
			contactmodule.addEventListener(ParamEvent.ROTATECUBE, rotateCube);
			contactmodule.x = Math.round(stage.stageWidth / 2 - cubeWidth / 2);
			contactmodule.y = Math.round(stage.stageHeight / 2 - cubeHeight / 2);
			addChild(contactmodule);
			contactmodule.cacheAsBitmap = true;
			contactmodule.visible = false;
		}
		
		//start building the cube
		private function buildCube():void
		{
			var frontFace:BitmapMaterial = new BitmapMaterial(homemodule.moduleBmp.bitmapData, true);
			frontFace.precision = 1;
		    frontFace.pixelPrecision = 1;
		    frontFace.minimumRenderSize = 1;
		    frontFace.smooth = true;   
		    frontFace.tiled = false;
			frontFace.interactive = true;
			//frontFace.smooth = true;
			
			var leftFace:BitmapMaterial = new BitmapMaterial(aboutmodule.moduleBmp.bitmapData, true);
			leftFace.precision = 1;
		    leftFace.pixelPrecision = 1;
		    leftFace.minimumRenderSize = 1;
		    leftFace.smooth = true;   
		    leftFace.tiled = false;
			leftFace.interactive = true;
			//leftFace.smooth = true;
			
			var rightFace:BitmapMaterial = new BitmapMaterial(contactmodule.moduleBmp.bitmapData, true);
			rightFace.precision = 1;
		    rightFace.pixelPrecision = 1;
		    rightFace.minimumRenderSize = 1;
		    rightFace.smooth = true;   
		    rightFace.tiled = false;
			rightFace.interactive = true;
			//rightFace.smooth = true;
			
			cube = new Cube(new MaterialsList( { left:rightFace, front:frontFace, right:leftFace } ), cubeWidth, cubeWidth, cubeHeight+Global.reflectionDistance+Global.reflectionHeight,1,1,1,0,Cube.BACK+Cube.BOTTOM+Cube.TOP);
			cube.useOwnContainer = true;
			cube.y = -Math.round(Global.reflectionDistance/2 + Global.reflectionHeight/2);
			cube.z = cubeWidth / 2;
			scene3d.addChild(cube);
			cube.visible = false;
			cube.rotationY = 180;
			renderCube();
		}
		
		//rotate left
		private function rotateLeft():void
		{
			
			Tweener.addTween(cube, { rotationY:cube.rotationY-90, time: transitionTime, onUpdate:renderCube,onComplete:showModule, transition: transitionType });
		}
		
		//rotate right
		private function rotateRight():void
		{
			
			Tweener.addTween(cube, { rotationY:cube.rotationY+90, time: transitionTime, onUpdate:renderCube,onComplete:showModule, transition: transitionType });
		}
		
		//hide the cube and display the current module
		private function showModule():void
		{
			switch (crtModule)
			{
				case 0: aboutmodule.visible = true; break;
				case 1: homemodule.visible = true; break;
				case 2: contactmodule.visible = true; break;
			}
			cube.visible = false;
			renderCube();
		}
		
		//render the cube
		private function renderCube():void
		{
			renderEngine.renderScene(scene3d, camera3d, viewPort3D);
		}
		
		
	}
}