package  com.oxylusflash.comingSoon 
{
	//import classes
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import com.oxylusflash.events.ParamEvent;
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.TextShortcuts;
	import caurina.transitions.properties.ColorShortcuts;
	ColorShortcuts.init();
	TextShortcuts.init();
	
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	public class NavButtons extends Sprite
	{
		//declaring variables
		public var bg:Sprite;
		public var leftButton:Sprite;
		public var rightButton:Sprite;
		private var leftButtonText:TextField;
		private var rightButtonText:TextField;
		private var rollOutColor:Number;
		private var rollOverColor:Number;
		
		//constructor with parameters
		public function NavButtons(leftBtnName:String, rightBtnName:String, newW:Number, rOutColor:Number, rOverColor:Number, removeThisButton:String="") 
		{	
			this.tabEnabled = false;
			this.tabChildren = false;
			bg.width = newW - 2;
			switch (removeThisButton) 
			{
				case "left": leftButton.visible = false; leftButton.mouseEnabled = false; break
				case "right": rightButton.visible = false; rightButton.mouseEnabled = false; break
			}
			
			
			leftButtonText = leftButton["Text"];
			leftButtonText.autoSize = "left";
			rightButtonText = rightButton["Text"];
			rightButtonText.autoSize = "left";
			leftButtonText.mouseEnabled = false;
			rightButtonText.mouseEnabled = false;
			leftButtonText.htmlText = leftBtnName;
			rightButtonText.htmlText = rightBtnName;
			leftButton.buttonMode = true;
			rightButton.buttonMode = true;
			
			
			rightButton.x = Math.round(newW - rightButtonText.width - 28);
			rightButton["arrow"].x = Math.round(rightButtonText.width+5);
			
			
			rollOutColor = rOutColor;
			rollOverColor = rOverColor;
			Tweener.addTween(leftButtonText, { _text_color:rollOutColor, time: 0.1, transition: "easeoutquad" } );
			Tweener.addTween(rightButtonText, { _text_color:rollOutColor, time: 0.1, transition: "easeoutquad" } );
			leftButton.addEventListener(MouseEvent.ROLL_OUT, onMouseHandler);
			leftButton.addEventListener(MouseEvent.ROLL_OVER, onMouseHandler);
			rightButton.addEventListener(MouseEvent.ROLL_OUT, onMouseHandler);
			rightButton.addEventListener(MouseEvent.ROLL_OVER, onMouseHandler);
			leftButton.addEventListener(MouseEvent.CLICK, onButtonsClick);
			rightButton.addEventListener(MouseEvent.CLICK, onButtonsClick);

		}
		
		//handler for the button click events
		private function onButtonsClick(e:MouseEvent):void 
		{
			
			var customEvent:ParamEvent = new ParamEvent("buttonclick", {variable:e.currentTarget.name});
			dispatchEvent(customEvent);
				
		}
		
		//roll out and roll over events handler
		private function onMouseHandler(e:MouseEvent):void 
		{
			switch (e.type)
			{
			case "rollOut":
			{
				Tweener.addTween(e.currentTarget["Text"], { _text_color:rollOutColor, time: 0.3,onUpdate:updRefEvent, transition: "easeoutquad" } );
				Tweener.addTween(e.currentTarget["arrow"], { _color:0xb6b6b6, time: 0.3, transition: "easeoutquad" } );
				break;
			}
			case "rollOver": 
			{
				Tweener.addTween(e.currentTarget["Text"], { _text_color:rollOverColor, time: 0.3,onUpdate:updRefEvent, transition: "easeoutquad" } ); 
				Tweener.addTween(e.currentTarget["arrow"], { _color:0x8e8e8e, time: 0.3, transition: "easeoutquad" } ); 
				break;
			}
			}
			
		}
		
		//dispatch the custom event
		private function updRefEvent():void
		{
			var customEvent:ParamEvent = new ParamEvent("updatereflection", {variable:null});
			dispatchEvent(customEvent);
		}
		
	}

}