﻿package com.oxylusflash.comingSoon 
{
	//importing classes
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.GradientType;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.utils.Timer;
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	public class Reflection extends Sprite
	{
		//declaring variables
		private var obj:Sprite;
		private var btData:BitmapData;
		private var reflection:Bitmap;
		private var timer:Timer;
		private var updateObj:Sprite;
		private var distance:Number;
		private var fadeMc:Sprite;
		private var rot:Boolean;

		
		//constructor with parameters
		public function Reflection(_obj:Object, _updateObj:Object, dist:Number,rotation:Boolean = false, blur:Boolean = true, positionRef:Number = 0) 
		{ 
			obj = Sprite( _obj);
			updateObj = Sprite (_updateObj);
			
			reflection = new Bitmap(new BitmapData(obj.width, obj.height, true, 0));
			
			reflection.y = positionRef;
			
			fadeMc = new Sprite;
			var grdMat:Matrix = new Matrix;
			rot = rotation;
			
			grdMat.createGradientBox(obj.width , obj.height , Math.PI * 0.5);
			
			fadeMc.graphics.beginGradientFill(GradientType.LINEAR, [0x00ff00, 0x0000ff], [1, 0], [0, 150], grdMat);
			fadeMc.graphics.drawRect(0, 0, obj.width, obj.height-5);
			fadeMc.graphics.endFill();
			fadeMc.cacheAsBitmap = true;
			
			fadeMc.x = reflection.x;
			fadeMc.y = reflection.y;
			
			this.addChild(fadeMc);	
			this.addChild(reflection);
			
			reflection.mask = fadeMc;
			if (blur) reflection.filters = [new BlurFilter(2,2,2)]
			
			this.addEventListener(Event.ENTER_FRAME, updateReflection, false, 0, true);
			
		}
		
		//update the reflection on enter frame
		private function updateReflection(e:Event):void 
		{
			reflection.bitmapData.fillRect(reflection.bitmapData.rect, 0);
			
			var flipMat:Matrix = new Matrix();
			flipMat.scale(1, -1);
			if (rot) {flipMat.translate(22, reflection.bitmapData.height)} else {flipMat.translate(0, reflection.bitmapData.height)};
			reflection.bitmapData.draw(updateObj, flipMat);
		}
		
	
	}

}