﻿package  com.oxylusflash.comingSoon 
{
	//importing classes
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import caurina.transitions.Tweener;
	import com.oxylusflash.events.ParamEvent;
	
	/**
	 * @version 28.05.2010
	 * @author bogdan@oxylus.ro
	 */
	
	public class SocialLinksHolder extends Sprite
	{
		//declaring variables
		public var Text:TextField;
		private var socialLinksArray:Array;
		private var lastX:Number;
		private var textEntries:Array;
		private var socialLinkIconHeight:Number;
		private var socialLinkIconWidth:Number;
		private var socialLinksHorizontalSpacing:Number;
		
		//constructor with parameters
		public function SocialLinksHolder(cssData:String,a:XMLList) 
		{
			this.tabEnabled = false;
			this.tabChildren = false;
			var sheet:StyleSheet = new StyleSheet();
			sheet.parseCSS(cssData);
			Text.alpha = 0;
			Text.styleSheet = sheet;
			textEntries = new Array();
			
			var nrLinks:Number = a.socialLinks.entry.length(); 
			socialLinkIconWidth = Number(a.socialLinkIconWidth.text());
			socialLinkIconHeight = Number(a.socialLinkIconHeight.text());
			socialLinksHorizontalSpacing = Number(a.socialLinksHorizontalSpacing.text());
			socialLinksArray = new Array();
			
			var linksHolder:Sprite = Sprite(this.addChild(new Sprite()));
			linksHolder.y = Math.round(Text.height + 8);
			
			lastX = 0;
			for (var i:int = 0; i < nrLinks; i++) 
			{
				var socialLink:SocialLink = SocialLink(linksHolder.addChild (new SocialLink(a.socialLinks.entry[i])));
				socialLink.addEventListener(ParamEvent.THUMBLOADED, updReflection);
				socialLink.x = lastX;
				socialLinksArray.push(socialLink);
				textEntries.push(a.socialLinks.entry[i].title.text());
				socialLink.addEventListener(MouseEvent.ROLL_OVER, onMouseHandler);
				socialLink.addEventListener(MouseEvent.ROLL_OUT, onMouseHandler);
				lastX += socialLinksHorizontalSpacing + socialLinkIconWidth;
			}
		}
		
		private function updReflection(e:Event):void 
		{
			var socialLinkLoadedEvent:ParamEvent = new ParamEvent("updatereflection", {variable:null});
			dispatchEvent(socialLinkLoadedEvent);
		}
		
		//mouse handler for roll over& roll out
		private function onMouseHandler(e:MouseEvent):void 
		{
			var crtIcon:Number = socialLinksArray.indexOf(e.currentTarget);
			switch (e.type)
			{
				case "rollOver": 
				{
					Text.htmlText = textEntries[crtIcon];
					Tweener.addTween(Text, { alpha:1, time: 0.3,onUpdate:updRefEvent, transition: "easeoutquad" });
					break;
				}
				case "rollOut": 
				{
					Tweener.addTween(Text, { alpha:0, time: 0.3,onUpdate:updRefEvent, transition: "easeoutquad" });
					break;
				}
			}
		}
		
		private function updRefEvent():void
		{
			updReflection(null);
		}
		
		//set the text width
		public function setTextWidth(startPos:Number, maxWidth:Number):void
		{
		
			Text.x = -startPos+10;
			Text.width = maxWidth-20;
		}
		
		//override the width property
		override public function set width(value:Number):void { }
		override public function get width():Number 
		{ 
			return lastX;
		}
		
		
	}

}